unit vennform;
(*
   Testiohjelma Venn-kaavioita varten.
   Miika Nurminen, 25.4.2004.
*)
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, contnrs, ComCtrls, StdCtrls, Grids,
  VennDiagram;

type

  TForm1 = class(TForm)
    Timer1: TTimer;
    GroupBoxChecks: TGroupBox;
    StringGrid1: TStringGrid;
    trackbar: TTrackBar;
    VennDiagram: TVennDiagram;
    procedure FormCreate(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure StringGrid1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
  private
  public
  end;

var
  Form1: TForm1;

implementation


{$R *.dfm}



procedure TForm1.FormCreate(Sender: TObject);
begin
  self.DoubleBuffered:=true;
  VennDiagram.AddPredicate(clRed);
  VennDiagram.AddPredicate(clGreen);
  VennDiagram.AddPredicate(clBlue);
  VennDiagram.SetCount:=TrackBar.Position;
end;



procedure TForm1.TrackBar1Change(Sender: TObject);
begin
  VennDiagram.SetCount:=TrackBar.Position;
end;


procedure TForm1.StringGrid1MouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  var a,b:longint;pred:TPredicate;
begin
  StringGrid1.MouseToCell(X,Y, a,b);
  if (b>=VennDiagram.SetCount) then Exit;
  if (a>=VennDiagram.PredicateCount) then Exit;
  with StringGrid1 do begin
    if length(Cells[a,b])=0 then begin
        Cells[a,b]:='x';
        pred:=pT;
    end else
    case Cells[a,b][1] of
      'x':begin
        Cells[a,b]:='n';
        pred:=pF;
      end;
      'n':begin
        Cells[a,b]:='';
        pred:=pN;
      end;
    end;
  end;
  VennDiagram.Predicates[a].SetMask(b,pred);
  Repaint;
end;

end.




